from _typeshed import Incomplete
from strictyaml import utils as utils
from strictyaml.exceptions import YAMLValidationError as YAMLValidationError
from strictyaml.ruamel.comments import (
    CommentedMap as CommentedMap,
    CommentedSeq as CommentedSeq,
)
from strictyaml.yamlpointer import YAMLPointer as YAMLPointer

unicode = str

class YAMLChunk:
    def __init__(
        self,
        ruamelparsed,
        pointer: Incomplete | None = ...,
        label: Incomplete | None = ...,
        strictparsed: Incomplete | None = ...,
        key_association: Incomplete | None = ...,
    ) -> None: ...
    def expecting_but_found(
        self, expecting, found: Incomplete | None = ...
    ) -> None: ...
    def while_parsing_found(self, what, found: Incomplete | None = ...) -> None: ...
    def process(self, new_item): ...
    def is_sequence(self): ...
    def is_mapping(self): ...
    def is_scalar(self): ...
    def found(self): ...
    def expect_sequence(self, expecting: str = ...): ...
    def expect_mapping(self): ...
    def expect_scalar(self, what) -> None: ...
    @property
    def label(self): ...
    @property
    def whole_document(self): ...
    @property
    def pointer(self): ...
    def fork(self, strictindex, new_value): ...
    def add_key_association(self, unprocessed_key, processed_key) -> None: ...
    @property
    def key_association(self): ...
    def make_child_of(self, chunk) -> None: ...
    def index(self, strictindex): ...
    def ruamelindex(self, strictindex): ...
    def val(self, strictkey): ...
    def key(self, key, strictkey: Incomplete | None = ...): ...
    def textslice(self, start, end): ...
    def start_line(self): ...
    def end_line(self): ...
    def lines(self): ...
    def lines_before(self, how_many): ...
    def lines_after(self, how_many): ...
    @property
    def contents(self): ...
    def strictparsed(self): ...
